SystemOrganization addCategory: #AppleScriptProgrammer!

Object subclass: #ClassRowOfOmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AppleScriptProgrammer'!

!ClassRowOfOmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/1/2011 14:32'!
newWithClass: aClass 

	| instance |
	instance := self new.
	instance class: aClass.
	^instance! !

!ClassRowOfOmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'as yet unclassified' stamp: 'hjo 9/1/2011 14:02'!
appleScriptVariableName

	^'St', class name! !

!ClassRowOfOmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'as yet unclassified' stamp: 'hjo 9/1/2011 14:03'!
class: aClass

	class := aClass.! !

!ClassRowOfOmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'as yet unclassified' stamp: 'hjo 9/2/2011 00:37'!
printAppleScriptOn: aWriteStream

	self printAppleScriptOn: aWriteStream classIsRoot:  false! !

!ClassRowOfOmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'as yet unclassified' stamp: 'hjo 9/2/2011 00:37'!
printAppleScriptOn: aWriteStream classIsRoot: aBoolean

	aWriteStream tab.
	aWriteStream tab.
	aWriteStream nextPutAll: 'set '.
	aWriteStream nextPutAll: self appleScriptVariableName.
	aWriteStream nextPutAll: ' to make new row at end'.
	
	aBoolean ifFalse:
		[aWriteStream nextPutAll: ' of children of '.
		aWriteStream nextPutAll: (self class newWithClass: class superclass) appleScriptVariableName].
	
	aWriteStream cr.
	aWriteStream tab.
	aWriteStream tab.
	aWriteStream nextPutAll: 'set text of cell 2 of '.
	aWriteStream nextPutAll: self appleScriptVariableName.
	aWriteStream nextPutAll: ' to '.
	aWriteStream nextPut: $".
	aWriteStream nextPutAll: class name.  
	aWriteStream nextPut: $".
	aWriteStream cr.
	aWriteStream tab.
	aWriteStream tab.
	aWriteStream nextPutAll: 'set text of cell 3 of '.
	aWriteStream nextPutAll: self appleScriptVariableName.
	aWriteStream nextPutAll: ' to '.
	aWriteStream nextPut: $".
	aWriteStream nextPutAll: class category.  
	aWriteStream nextPut: $".
	aWriteStream cr.! !

!ClassRowOfOmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'as yet unclassified' stamp: 'hjo 9/2/2011 00:38'!
printAsRootAppleScriptOn: aWriteStream 

	self printAppleScriptOn: aWriteStream classIsRoot:  true! !

Object subclass: #OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter
	instanceVariableNames: 'appleScriptStream dependencySorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AppleScriptProgrammer'!

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'adding class' stamp: 'hjo 9/1/2011 17:39'!
addClass: aClass
	
	self dependencySorter insert: aClass! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'adding class' stamp: 'hjo 9/2/2011 00:31'!
addClassTree: rootClass
	
	self dependencySorter insert: rootClass.
	rootClass allSubclasses do: [ :eachClass | self dependencySorter insert: eachClass ].! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'accessing' stamp: 'hjo 6/16/2009 17:51'!
appleScriptStream

	^appleScriptStream setDefault: #defaultAppleScriptStream for: self withSetter: #appleScriptStream:! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'accessing' stamp: 'hjo 6/16/2009 17:51'!
appleScriptStream: anObject
		
	appleScriptStream := anObject! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'defaults' stamp: 'hjo 6/16/2009 17:51'!
defaultAppleScriptStream

	^FileStream newFileNamed: 'oo.scpt'! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'defaults' stamp: 'hjo 9/1/2011 16:51'!
defaultDependencySorter

	^SuperClassDependencySorter new! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'accessing' stamp: 'hjo 9/1/2011 16:50'!
dependencySorter

	^dependencySorter setDefault: #defaultDependencySorter for: self  withSetter:  #dependencySorter:! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'accessing' stamp: 'hjo 9/1/2011 16:50'!
dependencySorter: anObject

	dependencySorter := anObject! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'selecting classes' stamp: 'hjo 9/1/2011 17:42'!
nonRootClasses

	^self dependencySorter sortedCollection copyWithoutAll: self rootClasses.    ! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'selecting classes' stamp: 'hjo 9/1/2011 17:41'!
rootClasses

	^self dependencySorter sortedCollection select: [:each| each superclass = nil ]! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'writing to stream' stamp: 'hjo 9/2/2011 00:40'!
writeAddedClassesToFile

	self appleScriptStream
		nextPutAll:
			'tell application "OmniOutliner"
	tell (make new document)
		make new column
		set name of column 2 to "class"
		set name of column 3 to "category"

'.
	self rootClasses do: [:rootClass| 
			ClassRowOfOmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter new
				class: rootClass;
				printAsRootAppleScriptOn: self appleScriptStream.
			self appleScriptStream cr.
	].

	self nonRootClasses
		do: [ :each | 
			ClassRowOfOmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter new
				class: each;
				printAppleScriptOn: self appleScriptStream.
			self appleScriptStream cr.
		].
	self appleScriptStream
		nextPutAll:
			'	end tell
end tell'.
	self appleScriptStream close! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'writing to stream' stamp: 'hjo 9/2/2011 02:12'!
writeAllClassesToFile
	
	"This wont take long to run. But, openning the file generated by this with AppleScript Editor(by Apple) will take humungous time."
	Smalltalk allClasses do: [:each| self addClass:  each ].
	self writeAddedClassesToFile! !
